diff --git a/django/contrib/localflavor/ar/forms.py b/django/contrib/localflavor/ar/forms.py
index 53721a1..57b5f8b 100644
--- a/django/contrib/localflavor/ar/forms.py
+++ b/django/contrib/localflavor/ar/forms.py
@@ -28,9 +28,9 @@ class ARPostalCodeField(RegexField):
         'invalid': _("Enter a postal code in the format NNNN or ANNNNAAA."),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=8, min_length=4, *args, **kwargs):
         super(ARPostalCodeField, self).__init__(r'^\d{4}$|^[A-HJ-NP-Za-hj-np-z]\d{4}\D{3}$',
-            min_length=4, max_length=8, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self, value):
         value = super(ARPostalCodeField, self).clean(value)
@@ -51,8 +51,8 @@ class ARDNIField(CharField):
         'max_digits': _("This field requires 7 or 8 digits."),
     }
 
-    def __init__(self, *args, **kwargs):
-        super(ARDNIField, self).__init__(max_length=10, min_length=7, *args,
+    def __init__(self, max_length=10, min_length=7, *args, **kwargs):
+        super(ARDNIField, self).__init__(max_length, min_length, *args,
                 **kwargs)
 
     def clean(self, value):
@@ -81,9 +81,9 @@ class ARCUITField(RegexField):
         'checksum': _("Invalid CUIT."),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(ARCUITField, self).__init__(r'^\d{2}-?\d{8}-?\d$',
-            *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self, value):
         """
diff --git a/django/contrib/localflavor/pl/forms.py b/django/contrib/localflavor/pl/forms.py
index ef4a38b..8b4d2f4 100644
--- a/django/contrib/localflavor/pl/forms.py
+++ b/django/contrib/localflavor/pl/forms.py
@@ -40,9 +40,9 @@ class PLPESELField(RegexField):
         'checksum': _(u'Wrong checksum for the National Identification Number.'),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(PLPESELField, self).__init__(r'^\d{11}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self, value):
         super(PLPESELField, self).clean(value)
@@ -77,9 +77,9 @@ class PLNationalIDCardNumberField(RegexField):
         'checksum': _(u'Wrong checksum for the National ID Card Number.'),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(PLNationalIDCardNumberField, self).__init__(r'^[A-Za-z]{3}\d{6}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self,value):
         super(PLNationalIDCardNumberField, self).clean(value)
@@ -129,9 +129,9 @@ class PLNIPField(RegexField):
         'checksum': _(u'Wrong checksum for the Tax Number (NIP).'),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(PLNIPField, self).__init__(r'^\d{3}-\d{3}-\d{2}-\d{2}$|^\d{2}-\d{2}-\d{3}-\d{3}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self,value):
         super(PLNIPField, self).clean(value)
@@ -169,9 +169,9 @@ class PLREGONField(RegexField):
         'checksum': _(u'Wrong checksum for the National Business Register Number (REGON).'),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(PLREGONField, self).__init__(r'^\d{9,14}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
     def clean(self,value):
         super(PLREGONField, self).clean(value)
@@ -209,7 +209,7 @@ class PLPostalCodeField(RegexField):
         'invalid': _(u'Enter a postal code in the format XX-XXX.'),
     }
 
-    def __init__(self, *args, **kwargs):
+    def __init__(self, max_length=None, min_length=None, *args, **kwargs):
         super(PLPostalCodeField, self).__init__(r'^\d{2}-\d{3}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length, min_length, *args, **kwargs)
 
diff --git a/tests/regressiontests/forms/localflavor/ar.py b/tests/regressiontests/forms/localflavor/ar.py
index 9c67269..81668b3 100644
--- a/tests/regressiontests/forms/localflavor/ar.py
+++ b/tests/regressiontests/forms/localflavor/ar.py
@@ -96,4 +96,4 @@ class ARLocalFlavorTests(LocalFlavorTestCase):
              '27-10345678-1': error_invalid,
              u'27-10345678-1': error_invalid,
         }
-        self.assertFieldOutput(ARCUITField, valid, invalid)
+        self.assertFieldOutput(ARCUITField, valid, invalid, field_kwargs={'max_length':15, 'min_length':4})
diff --git a/tests/regressiontests/forms/localflavor/pl.py b/tests/regressiontests/forms/localflavor/pl.py
index 7225abe..4a0c4c9 100644
--- a/tests/regressiontests/forms/localflavor/pl.py
+++ b/tests/regressiontests/forms/localflavor/pl.py
@@ -443,7 +443,7 @@ class PLLocalFlavorTests(LocalFlavorTestCase):
             '80': error_format,
             '800716106AA': error_format,
         }
-        self.assertFieldOutput(PLPESELField, valid, invalid)
+        self.assertFieldOutput(PLPESELField, valid, invalid, field_kwargs={'max_length':11, 'min_length':4})
 
     def test_PLNationalIDCardNumberField(self):
         error_checksum = [u'Wrong checksum for the National ID Card Number.']